sub parse_lst {
  my $file = 'x.lst';
  open my $fh, $file or die;
  my $text = '';
  while (<$fh>) {
    if (/^\s+\d+ (= [0-9A-F]{4})\t/) {
      $text .= "$1\n";
    }
    elsif (/^\s+\d+ ([0-9A-F]{4}( [0-9A-F]{2})*)(\t| \+)/) {
      my $val = $1;
      $val =~ s/ //g;
      substr($val, 4, 0) = ' ' if length($val) > 4;
      substr($val, 15, 2) = '' if length($val) > 15;
      $text .= "$val\n" if !($val =~ / (20|4C)0000$/);# || $val =~ / 0000$/);
    }
  }

  $text;
}

sub parse_amac {
  my $file = 'p2list.txt';
  open my $fh, $file or die;
  my $text = '';
  while (<$fh>) {
    if (/^ {6}(= [0-9A-F]{4})/) {
      $text .= "$1\n" if !(/^\s+= [0-9A-F]{4}\s+IF\b/);
    }
    elsif (/^([0-9A-F]{4})  = [0-9A-F]{4}/) {
      $text .= "= $1\n";
    }
    elsif (/^([0-9A-F]{4}(  ([0-9A-F]{2})*))/) {
      my $val = $1;
      $val =~ s/  //;
      substr($val, 4, 0) = ' ' if length($val) > 4;
      $text .= "$val\n" if !/PROC$/;
    }
  }

  $text;
}

sub write_file {
  my ($file, $text) = @_;

  open my $fhw, '>', $file;
  print $fhw $text;
}

write_file('xamac.txt', parse_amac());
write_file('xlst.txt', parse_lst());

